using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using WWHelp4v2;

namespace WWHelp4Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
    // Reference to WWHelp4 COM object
    //
    private IAPI  smWWHelp4API;

    private System.Windows.Forms.Button button1;
    private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
      //
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

      Uri                      VarBaseHelpUri;
      bool                     bVarFoundWWHAPIDirectory;
      System.IO.DirectoryInfo  VarParentInfo;

      // Guess help set location
      //
      VarBaseHelpUri = new Uri(new Uri(System.Windows.Forms.Application.ExecutablePath), "../../../../../../../../example/helpset");

      // Attempt to automatically locate help set
      //
      bVarFoundWWHAPIDirectory = false;
      VarParentInfo = System.IO.Directory.GetParent(System.Windows.Forms.Application.ExecutablePath);
      while (( ! bVarFoundWWHAPIDirectory) &&
             (VarParentInfo.FullName.Length > 6))
      {
        if (VarParentInfo.Name == "wwhapi")
        {
          String  VarHelpSetPath;

          // Directory exists?
          //
          VarHelpSetPath = System.IO.Path.Combine(VarParentInfo.FullName, "example");
          VarHelpSetPath = System.IO.Path.Combine(VarHelpSetPath, "helpset");
          if (System.IO.Directory.Exists(VarHelpSetPath))
          {
            // Found help set!
            //
            VarBaseHelpUri = new Uri(VarHelpSetPath);
          }

          bVarFoundWWHAPIDirectory = true;
        }
        else
        {
          VarParentInfo = VarParentInfo.Parent;
        }
      }

      // Initialize WWHelp 4.0 API
      //
      smWWHelp4API = new CAPIClass();
      smWWHelp4API.Startup(VarBaseHelpUri.AbsoluteUri);
    }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}

        // Uninitialize WWHelp 4.0 API
        //
        smWWHelp4API.Shutdown();
      }
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.button1 = new System.Windows.Forms.Button();
      this.button2 = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(16, 16);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(112, 48);
      this.button1.TabIndex = 0;
      this.button1.Text = "Help";
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // button2
      // 
      this.button2.Location = new System.Drawing.Point(144, 16);
      this.button2.Name = "button2";
      this.button2.Size = new System.Drawing.Size(112, 48);
      this.button2.TabIndex = 1;
      this.button2.Text = "Help with Navigation";
      this.button2.Click += new System.EventHandler(this.button2_Click);
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(272, 77);
      this.Controls.Add(this.button2);
      this.Controls.Add(this.button1);
      this.Name = "Form1";
      this.Text = "WebWorks Help 4.0 API";
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    public void DisplayHelp(String  ParamContext,
                            String  ParamTopic)
    {
      smWWHelp4API.DisplayHelp(ParamContext, ParamTopic);
    }

    public void DisplayHelpWithNavigation(String  ParamContext,
                                          String  ParamTopic)
    {
      smWWHelp4API.DisplayHelpWithNavigation(ParamContext, ParamTopic);
    }

    private void button1_Click(object sender, System.EventArgs e)
    {
      DisplayHelp("beta", "section2");
    }

    private void button2_Click(object sender, System.EventArgs e)
    {
      DisplayHelpWithNavigation("alpha", "section2");
    }
	}
}
